/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.5 vom 1.5 2002
  */
/**eine einfach verkettete Liste */

public class EinfachVerketteteListe {
  protected EVK_Listenelement head;
/** leerer Konstruktor */
  public EinfachVerketteteListe() {
    head = null;
  }
  /** gibt eine Liste ohne das erste Element zurck */
  public EinfachVerketteteListe tail() {
    EinfachVerketteteListe evk = new EinfachVerketteteListe();

    if (!this.isEmpty())
      evk.head = head.getNext();
    return evk;
  }
  /** gibt nur einen Zeiger auf das erste Element der Liste (also Listenelement) zurck 
  *@return erstes Listenelement (EVK_ListenElement)
  */
  public EVK_Listenelement headElement() {
    return head;
  }
  /** gibt nur das erste Element zurck 
  *@return erstes Element (type Objekt)
  */
  public Object head() {
    if (!this.isEmpty())
      return head.getElement();
    else return null;
  }
  /** gibt die Lnge */
  public int length() {
    int z = 0;
    EVK_Listenelement n = head;

    while (n != null) {
      n = n.getNext();
      z = z+1;
    }
    return z;
  }
  /** fgt ein neues Element am Anfang ein */
  public void addFirst(Object o) {
    EVK_Listenelement n = new EVK_Listenelement();

    n.setElement(o);
    n.setNext(head);
    head = n;
  }
/** fgt ein neues Element am Ende ein */
  public void addLast(Object o) {
    
    if (this.isEmpty()) this.addFirst(o);
    else {
      EVK_Listenelement n, ok;
      n = head;
      while (n.getNext() != null)
        n = n.getNext();
      ok = new EVK_Listenelement();
      ok.setElement(o);
      n.setNext(ok);
    }
  }
  /** schaut, ob sich ein gegebenes Objekt in der Liste befindet */
  public boolean isIn(Object o){
    EVK_Listenelement a=head;
    while (a != null &&  !a.getElement().equals(o))
      a = a.getNext();
    return a != null;
    
  }
  /** gibt das i-te Element der Liste zurck */
  public EVK_Listenelement getListElement(int i){
    EVK_Listenelement a=head;
    for (int j=0;a!=null && j<i;j++)
      a = a.getNext();
    return a;
  }
  /** lscht ein Listenelement mit dem gegeben Objekt als Element
  *@return den index des gelschten Elements
  */
  public int removeObject(Object o){
    EVK_Listenelement a=head, v= null;
    int i=0;
    
    while (a!=null && !a.getElement().equals(o)){
      i++;
      v = a;
      a = a.getNext();
    }
    if (a == head) head = head.getNext();
    else if (a == null) return -1;
    else v.setNext(a.getNext());
    return i;
  }
/** wandelt die Liste in einen String indem jedes Objekt einzeln in einen String gewandelt wird */
  public String toString() {
    EVK_Listenelement n = head;
    String str;
    str = "[";
    while (n != null) {
    	str += n.getElement();
    	if ((n = n.getNext()) != null)
      		str += ",\r\n";
    }
    str += "]";
    return str;
  }
/** Liste leer? */
  protected boolean isEmpty(){
    return head == null;
  }

}