/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.2a vom 20.4 2002
  */
/**Klasse, die eine einzelne Person reprsentiert */
class Person {
	protected String name, vorname;
	
	public Person(){
		name=null;
		vorname=null;
	}
	public Person(String N,String Vn){
		name = N;
		vorname = Vn;
	}
	public String getName(){ 
		return name;
	}
	public String getVorname(){
		return vorname;
	}
	public String toString(){
		return (String)(vorname + " " + name);
	}
	public int compareTo(Object o){
		if (o instanceof Person){
			int ret;
			if ((ret=((Person)o).getName().compareTo(name))==0)
				return -((Person)o).getVorname().compareTo(vorname);
			else return -ret;
		}
		else throw new IllegalArgumentException("Person kann nur mit einer Person verglichen werden!");
	}
	
	public boolean equals(Object o){
		if (o instanceof Person){
			boolean ret;
			if ((ret=((Person)o).getName().equals(name))==true)
				return ((Person)o).getVorname().equals(vorname);
			else return ret;
		}
		else throw new IllegalArgumentException("Person kann nur mit einer Person verglichen werden!");
	}
}