public class EinfachVerketteteListe {
  protected EVK_Listenelement head;

  public EinfachVerketteteListe() {
    head = null;
  }
  
  public EinfachVerketteteListe tail() {
    EinfachVerketteteListe evk = new EinfachVerketteteListe();

    if (!this.isEmpty())
      evk.head = head.getNext();
    return evk;
  }

  public Object head() {
    if (!this.isEmpty())
      return head.getElement();
    else return null;
  }
  public int length() {
    int z = 0;
    EVK_Listenelement n = head;

    while (n != null) {
      n = n.getNext();
      z = z+1;
    }
    return z;
  }
  public void addFirst(Object o) {
    EVK_Listenelement n = new EVK_Listenelement();

    n.setElement(o);
    n.setNext(head);
    head = n;
  }

  public void addLast(Object o) {
    
    if (this.isEmpty()) this.addFirst(o);
    else {
      EVK_Listenelement n, ok;
      n = head;
      while (n.getNext() != null)
        n = n.getNext();
      ok = new EVK_Listenelement();
      ok.setElement(o);
      n.setNext(ok);
    }
  }

  public boolean isIn(Object o){
    return getListElement(o) != null;
  }

  protected  EVK_Listenelement getListElement(Object o){
    EVK_Listenelement a=head;

    
    while (a != null && a.getElement() != o)
      a = a.getNext();
    return a;
  }

  public void removeObject(Object o){
    EVK_Listenelement a=head, v= null;

    
    while (a != null && a.getElement() != o){
      v = a;
      a = a.getNext();
    }
    if (a == head) head = head.getNext();
    else if (a == null) return;
    else v.setNext(a.getNext());
  }

  public String toString() {
    EVK_Listenelement n = head;
    String str;
    str = "[";
    while (n != null) {
    str += n.getElement();
    if ((n = n.getNext()) != null)
      str += ", ";
    }
    str += "]";
    return str;
  }

  protected boolean isEmpty(){
    return head == null;
  }

}