(define l1 (list 1 0 2 3))
(define l2 (list 1 2 3 -4))

(define (skalar-p v w erg)
		(if (or (null? v) (null? w)) erg
			(skalar-p (cdr v) (cdr w) (+ erg (* (car v) (car w))))
		)
)
(define (skalar-product v w) (skalar-p v w 0))

;------------------------------------------------------------------------------
(define m1 (list '(1 2 3 4) '(5 6 7 8) '(9 10 11 12)))

(define (mvp m v erg)
	(if (or (null? m) (null? v)) erg
		(mvp (cdr m) v (append erg (list (skalar-product (car m) v))))
	)
)
(define (matrix-vector-produkt m v) (mvp m v (list)))
;------------------------------------------------------------------------------

(define (tr m erg i)
		(if (null? m) erg
		(tr (cdr m) (append erg (list (list-ref (car m) i))) i)
		)
)
(define (trans m erg i)
		(if (or (not (list? (car m))) (= i (length (car m)))) erg
		(trans m (append erg (list (tr m (list) i))) (+ i 1))
		)
)
(define (transpose m) (if (null? m) (list) (trans m (list) 0)))
;--------------------------------------------------------------------------------

(define m2 (list '(1 0 1 2) '(0 1 2 2)))
(define m3 (list '(1 1) '(2 3) '(0 1) '(1 0)))

(define (mmp m n erg i)
	(if (or (not (list? (car n))) (= i (length (car n)))) erg
	(mmp m n (append erg (list (matrix-vector-produkt m (list-ref (transpose n) i)))) (+ i 1))
	)
) 
(define (matrix-matrix-product m n)
	(if (or (null? m) (null? n)) (list)
	(transpose (mmp m n (list) 0))
	)
)