(define (rec x erg) 
	(cond	( (> x 3999) (display "value over 3999 not allowed"))
	      	( (or (= x 1000) (> x 1000)) (rec (remainder x 1000) (string-append erg (make-string (quotient x 1000) #\M))))
		( (or (= x 900) (> x 900)) (rec (- x 900) (string-append erg "CM")))
		( (or (= x 500) (> x 500)) (rec (- x 500) (string-append erg "D")))
		( (or (= x 400) (> x 400)) (rec (- x 400) (string-append erg "CD")))
		( (or (= x 100) (> x 100)) (rec (remainder x 100) (string-append erg (make-string (quotient x 100) #\C))))
		( (or (= x 90) (> x 90)) (rec (- x 90) (string-append erg "XC")))
		( (or (= x 50) (> x 50)) (rec (- x 50) (string-append erg "L")))
		( (or (= x 40) (> x 40)) (rec (- x 40) (string-append erg "XL")))
		( (or (= x 10) (> x 10)) (rec (remainder x 10) (string-append erg (make-string (quotient x 10) #\X))))
		( (= x 9) (string-append erg "IX"))
		( (or (= x 5) (> x 5)) (rec (- x 5) (string-append erg "V")))
		( (= x 4) (string-append erg "IV"))
		( (> x 0)  (string-append erg (make-string x #\I)))
                (else erg)
	)

)
(define (dec->rom x) (rec x ""))