(define alist '((#\M 1000) (#\D 500) (#\C 100) (#\L 50) (#\X 10) (#\V 5) (#\I 1)))
(define (rom->dec x) 
		(cond ( (or (not (string? x)) (eqv? "" x)) (display "illegal input") )
		      (else (let ( (a (lrom->ldec (string->list (string-upcase x)) (list)) ) )
		      	         (if (eqv? a #f) (display "kein rmischer Buchstabe") (rom a 0))
		      	    )
		      )
		)
) 

(define (lrom->ldec x y) (if (null? x) y
				(if (not (eqv? #f (assv (car x) alist))) (lrom->ldec (cdr x) (append y (cdr (assv (car x) alist)))) 
				 #f)
			)
)

(define (rom l erg) (cond ( (null? l) erg )
			  ( (= (length l) 1) (+ erg (car l)) )
			  ( (< (car l) (list-ref l 1)) (rom (list-tail l 2) (+ erg (- (list-ref l 1) (car l)))) )
			  (else (rom (cdr l) (+ erg (car l))) )
			
		    )
)
		