import java.awt.*;
import java.awt.event.*;

/** Implementiert den Dialog, der beim korrigieren angezeigt wird
  * @version 1.0
  * @author Markus Burger-Scheidlin 2683838
  *         Vitus Lorenz-Meyer 2691370
  */
class CorrectDialog extends Dialog{
	public boolean running;
	
	/** Konstruktor
	  * @param parent das VaterFenster... fenster brauchen sowas immer ;)
	  */
	public CorrectDialog(Frame parent){
		super(parent,"correct word",false);
		setResizable(false);
		running=true;
	
		//location vom Parent holen und dies fenster 400 in x und 150 in y in seine Area hinnein setzen
		Point parloc = parent.getLocation();
		setLocation(parloc.x + 400, parloc.y + 150);
	
		//fenster vorbereiten fr Schaltflchen-> BorderLayout
		setLayout(new BorderLayout());
		add("North", new Label("correct - Wort ver- oder unverndert ins Wrterbuch bernehmen",Label.CENTER));
		add("Center", new Label("next - nchstes Wort, keine nderung",Label.CENTER));
		
		Panel panel = new Panel();
		panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	
		//im Sden wird noch eine neue Flche hinzugefgt, mit den 2 Buttons a und b
		Button a=new Button("correct word");
		a.addActionListener((ActionListener)parent);
		panel.add(a);
		Button b=new Button("next");
		b.addActionListener((ActionListener)parent);
		panel.add(b);
	
		//adden
		add("South", panel);
		
		addWindowListener(	//neuer close listener frs Fenster, hauptschlich wegen running
     	   	new WindowAdapter(){
         		public void windowClosing(WindowEvent event)
         		{
           			//new MessageBox("Info","CD wird geschlossen");
           			running=false;
           			setVisible(false);
       		  	}
	       	});
	       	pack();		//packen und warten, dass visible=true gesetzt wird... macht Parent
	       	//show();
	}
	
}