import java.awt.*;
import java.awt.event.*;
/** Kleine Hilfs-Klasse, die eine Messagebox anzeigt
  * @version 1.0
  * @author Markus Burger-Scheidlin 2683838
  *         Vitus Lorenz-Meyer 2691370
  */
class MessageBox extends Dialog implements ActionListener{
	
	/** result, nur fr die unsaved-changes MSB	
	*/
	public int result=0;
	
	/**statische Variable... wei auch nciht mehr wofr
	*/
	static Frame paret;
	
	/** Konstruktor, der die KLassenVar als Parent benutzt
	  * @param caption Titel des Fensters, msg die Nachricht
	  */
	public MessageBox(String caption, String msg){
		this(caption,msg,paret);
	}
	
	/** Konstruktor
	  * @param caption Titel des Fensters, msg die Nachricht
	  * @param parent ist das Vater-Fenster
	  */
	public MessageBox(String caption, String msg,Frame parent){
		//Vaterklassen-Konstruktor, und Modal
		super(parent,caption,true);
		paret=parent;
		setResizable(false);
		
		//location vom Parent holen und dies fenster 400 in x und 150 in y in seine Area hinnein setzen
		Point parloc = parent.getLocation();
		setLocation(parloc.x + 100, parloc.y + 100);

		//fenster vorbereiten fr Schaltflchen-> BorderLayout
		setLayout(new BorderLayout());
		add("Center", new Label(msg,Label.CENTER));
		
		Panel panel = new Panel();
		panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		
		Button a=new Button("OK");
		a.addActionListener(this);
		
		panel.add(a);
		add("South", panel);
		//neuer close listener frs Fenster
		addWindowListener(
     	   	new WindowAdapter(){
         		public void windowClosing(WindowEvent event)
         		{
           			endDialog();
       		  	}
	       	});
	       	pack();	//packen und...
	       	show();//anzeigen
     	
	}
	
	/** Konstruktor fr die unsaved-changes MSB
	  * @param parent ist das Vater-Fenster
	  */
	public MessageBox(Frame parent){
		
		//Vaterklassen-Konstruktor, und Modal
		super(parent,"unsaved changes",true);
		setResizable(false);
		
		Point parloc = parent.getLocation();
		setLocation(parloc.x + 100, parloc.y + 100);

		setLayout(new BorderLayout());
		add("Center", new Label("Sie haben ungespeicherte nderungen, wollen Sie wirklich beenden?",Label.CENTER));
		
		Panel panel = new Panel();
		panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		
		Button a=new Button("OK");
		a.addActionListener(this);
		
		panel.add(a);
		a=new Button("Abbrechen");
		a.addActionListener(this);
		
		panel.add(a);
		a=new Button("Speichern");
		a.addActionListener(this);
		
		panel.add(a);
		add("South", panel);
		
		addWindowListener(
     	   	new WindowAdapter(){
         		public void windowClosing(WindowEvent event)
         		{
           			endDialog();
       		  	}
	       	});
	       	pack();
	       	show();
     	
	}
	
	/** wird aufgerugen, wenn was im Fenster passiert ist
	  * @param event ist ein Event Object, das besagt, was passiert ist
	  */
	public void actionPerformed(ActionEvent event)
  	{
		String cmd = event.getActionCommand();	//liefert den mit der betgtigeten Schaltflche ass. code
		if (cmd.equals("OK"))
			endDialog();  
    		else if (cmd.equals("Abbrechen")){
    			result=1;	//1 fr abbrechen
    			endDialog();
    		}else if (cmd.equals("Speichern")){
    			result=2;	//2 fr speichern
    			endDialog();
    		}
    		return;
    	}
    	
    	/** beendet den Dialog
	  */
	void endDialog()
   	{
	     	setVisible(false);
     		dispose();
     		((Window)getParent()).toFront();
     		getParent().requestFocus();
	}
}