/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.5 vom 1.5 2002
  */
/**Klasse, die ein einzelnes Listenelement reprsentiert */
public class EVK_Listenelement {
  /** Element */
  protected Object element;
  /** nextes Element */
  protected EVK_Listenelement next;
/** leerer Konstruktor */
  public EVK_Listenelement() {
    element = null;
    next = null;
  }
/** Konstruktor gleich mit Angabe vom Elemnt und des nchsten Elementes*/
    public EVK_Listenelement(Object e, EVK_Listenelement n) {
    element = e;
    next = n;
  }
/** setzt das nchste Element */
  public void setNext(EVK_Listenelement n){
    next = n;
  }
/** Liefert das nchste Element */
  public EVK_Listenelement getNext(){
    return next;
  }
/** setzt das Element */
  public void setElement(Object o) {
    element = o;
  }
/** Liefert das Element */
  public Object getElement(){
    return element;
  }
/** finalisierungsmethode... wird eh nicht garantiert aufgerufen ;) */
  protected void finalize() throws Throwable{
    next = null;
    element = null;
    super.finalize();
  }
}