/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.2a vom 20.4 2002
  */
/**Klasse, die eine Liste von Personen reprsentiert */
class Personen{
	protected EinfachVerketteteListe liste;
	
	public Personen(){
		liste = new EinfachVerketteteListe();
	}
	
	public void addPerson(Person per){
		liste.addFirst(per);
		System.out.println("added entry in Personen method");
	}
	
	public int anzahl(){
		return liste.length();
	}
	
	public Person getFirst(){
		return (Person)liste.head();
	}
	
	public void personenLoeschen(){
		liste = new EinfachVerketteteListe();
	}
	/** lscht eine Person aus der Liste
	*@return den index der gelschten Person (0-basiert)
	*/
	public int personLoeschen(Person per){
		if (!liste.isIn(per)){
			System.out.println("Person nicht in Liste vorhanden!");
			return -1;
		}else return (liste.removeObject(per));
		
	}
	
	public boolean enthaeltPerson(Person per){
		return liste.isIn(per);
	}
	
	public String toString(){
		return liste.toString();
	}
}