/** Programm zur Verwaltung von Personen
  * @author Vitus Lorenz-Meyer
  * @version 1.2a vom 20.4 2002
  */
/**Klasse, die ein Adressbuch reprsentiert */
class Personenbuch extends Personen implements Adressbuch{
	protected int laenge;
	protected Person_voll first,last;
	
	/** leerer Konstruktor */
	public Personenbuch(){
		first=last=null;
		laenge=0;
	}
	/** berschriebene Funktion, die eine Person sortiert in die Liste einfgt */
	public void addPerson(Person_voll per){
		EinfachVerketteteListe a = liste,v=null;
		
		laenge++;
		if (liste.isEmpty()){
			liste.addFirst(per);	//am Anfang einfgen
			first=last=per;		//und first und last auf einziges Element zeigen lassen
			System.out.println("added entry at first in personenbuch method");
		}
		else{
			int i=0;
    			while (!a.isEmpty() && per.compareTo(a.head()) > 0){
      				v = a; i++;
      				a = a.tail();
    			}		//i enthlt jetzt den nullbasiert index, wo das neue El eingefgt werden soll
    			if (i==0) first=per;	//falls am Anfang eingefgt wird, first Zeiger umbiegen
			else if (i==liste.length()) last=per;	//wenn am Ende, last Zeiger umbiegen
			System.out.println("Eintraege:" + liste.length()+ ", eingefgt nach " + i+". Eintrag in Personenbuch-method");
			a.addFirst(per);	//nun am Anfang von der verbleibenden Liste einfgen
			if (v!=null) v.headElement().setNext(a.headElement());	//und falls Vorgnger vorhanden (dann ist v!=null)
					//next Zeiger von v umbiegen
						
		}
	}
	/** liefert die Anzahl der Personen im Buch*/
	public int anzahl(){
		return laenge;
	}
	/** liefert die Erste Person */
	public Person getFirst(){
		return (Person_voll)first;
	}
	/** liefert letzte Person */
	public Person getLast(){
		return (Person_voll)last;
	}
	/** lscht eine durch vor-und nachname spez. Person */
	public void personLoeschen(String vorname, String nachname){
		int i;
		if (-1 != (i=super.personLoeschen(new Person(nachname,vorname)))){	//gibt -1 fals fehlgeschlagen
			laenge--;
			if (i==0) first=(Person_voll)liste.head(); //falls erstes Element war, first umbiegen
			else if (i==liste.length()) last=(Person_voll)liste.getListElement(i-1).getElement(); //wenn letztes last umbiegen
			System.out.println("deleted " +i+".ten Eintrag in Personenbuch method");
		}
		
			
	}
	/** schaut, ob eine Person in der Liste enthalten ist */
	public boolean enthaeltPerson(String vorname, String nachname){
		return super.enthaeltPerson(new Person(nachname,vorname));
	}
	/** lscht alle Personen */
	public void personenLoeschen(){
		super.personenLoeschen();
		first=last=null;
		laenge=0;
		System.out.println("deleted all entrys in Personenbuch meth");
	}
	/** liefert wieder ein Adressbuch, das alle Personen mit gesuchtem Nachnamen enthlt*/
	public Adressbuch personAusgeben(String nachname){
		Personenbuch ret = new Personenbuch();
		EinfachVerketteteListe evk = liste;
		Person_voll p;
		
		for(;null!=(p=(Person_voll)evk.head());evk = evk.tail())
			if (((p.getName()).compareTo(nachname))==0)
				ret.addPerson(p);
				
		return ret;
		
	}
	
	/** liefert wieder ein Adressbuch, das alle Personen mit gesuchtem String im Namen enthlt*/
	public Adressbuch suche (String Muster){
		
		Personenbuch ret = new Personenbuch();
		EinfachVerketteteListe evk = liste;
		Person_voll p;
		
		for(;null!=(p=(Person_voll)evk.head());evk = evk.tail())
			if ((((String)p.toString()).indexOf(Muster))!=-1)
				ret.addPerson(p);
		
		return ret;
		
	}
	/** Adressbuch in String umwandeln*/
	public String toString(){
		return liste.toString();
	}
}