import java.util.*;
import java.lang.*;

/** Programm zur Verwaltung Benzin-Kosten
    Klasse, die die Auswertung vornimmt 

  * @author Vitus Lorenz-Meyer
  * @version 1.5 vom 31. Januar 2002 */
class Auswertung {
	
	static float price = .8f; 		//statischer Benzin-Preis, liegt bei 0,80
	static int lp100 = 8;
	float gefahren=0,getankt=0,bezahlt=0;
		
	
	/** main: Das Hauptprogramm tankt so hufig, wie told (oder 45x) ;) 
	  * @param args Argumente */
	public static void main(String[] args){
		int anz = 45;
		if (args.length>0){		//wenn ein Argument bergeben wurde->Umwandlung in int, sonst def:45x tanken
			Integer I_anz = new Integer(args[0]);
			anz = I_anz.intValue();
		}
		
		Tanken TankVorgnge[] = new Tanken[anz];	//Array von TankVorgngen
		Random r = new Random();
		float tempKM,tempMenge,tempP;
		
		for (int i = 0; i<anz; i++){			//einzelne Tankvorgnge...
	  		tempKM = (((r.nextFloat()*1000)+150) % 1000); //randomize die gefahrenen Kilometer, min=150,max=1000
	  		tempKM = ((float)Math.round(tempKM*100))/100; //und wieder runden auf 2 Nachkommastellen
	  		r.nextFloat();	r.nextInt();		//Java tendiert meiner Meinung nach dazu, keine allzu groe Dynamik bei den Rand-Zahlen aufzuweisen (kleine Zahl=>wieder kleine Zahl),
	  						//deshalb habe ich hier noch 2 Aufrufe eingebaut ;)
	  		
	  		tempMenge = (tempKM/100)*(lp100 + ((r.nextFloat()*100)%3)-1f);  //getankte Menge: Kilometer/100 mal ca. (10Liter/100km plus eine kleine zufllige Zahl (max:3-1 (damit sie auch negativ wird, denn irgendwie passiert das sonst nie...scheiss Java)))
	  		tempMenge = ((float)Math.round(tempMenge*100))/100;	//und wieder runden auf 2 Nachkommastellen
	  		r.nextFloat();	r.nextDouble();		//nochmal 2 Vertuschungsaufrufe
	  		
	  		tempP = price+((r.nextFloat()-0.2f) % 0.3f);	//bezahlter Preis/l: fester Preis + kleine zufllige Zahl(max:2-0.2)
	  		tempP = ((float)Math.round(tempP*100))/100;	
	  		//Ausgabe dieses tankens, Liter, preis/l,km und Verbrauch
	  		System.out.println("\nNr. " + i + ":\t" + tempKM + "km, getankt " + tempMenge + "l zu " + tempP + " Euro =\t" + (((float)Math.round((tempP*tempMenge)*100))/100)
	  		+ " Euro\nVerbr./100Km liegt bei " + (tempMenge/(tempKM/100)) );
	  		TankVorgnge[i] = new Tanken(tempP,tempKM,tempMenge); //und hinzufgen eines neuen Tank-Objects zum Array
	  	}	//Auswertungs-Object erzeugen und Array bergeben:
	  	Auswertung a = new Auswertung(TankVorgnge,anz);
	}
		
	/** Auswertung-Konstruktor 
	  * @param Tanken[] Array von Tankvorgngen, anzahl die Anzahl der Eintrge im Array */
	public Auswertung(Tanken[] t, int anzahl){
		
		for (int i=0;i<anzahl;i++){
			gefahren+= t[i].km;
			getankt += t[i].menge;
			bezahlt += t[i].preis*t[i].menge;
		}
		
		System.out.print("\nAuswertung:\n");
		System.out.print("-----------------------\n   bei " + anzahl + "x tanken:\n");
		System.out.println("Gesamtstrecke:\t" + gefahren + "km\nGesamtkosten:\t" + bezahlt + 
		" Euro\nDurchschnittsverbrauch / 100km:\t" + (getankt/(gefahren/100)) + "l\nKosten / Km:\t" + (((float)Math.round(((bezahlt/gefahren)*10000))/10000)) + " Euro");
	}	

}

