(define (rek isbn i val) (cond  
				((or (char-whitespace? (string-ref isbn i)) (eqv? (string-ref isbn i) #\-)) (rek isbn (- i 1) val)) 
				((not (char-numeric? (string-ref isbn i))) #f)
				((= val 10) (* (char->digit (string-ref isbn i)) 10))
				(else (let ( (a (rek isbn (- i 1) (+ val 1))) )
					   ( if (eqv? a #f) #f
						(+ a (* (char->digit (string-ref isbn i)) val))
					   )
				      )
				      
				)
			) 
)
(define (isbn-check isbn)
	( let* ( (checka (string-ref isbn (- (string-length isbn) 1) ))
	         (check (if (char-ci=? checka #\x) 10 (if (char-numeric? checka) (char->digit checka) #\z))) )
	       (cond ( (OR (char? check) (< check 1)) #f)
	      	     ( (AND (not (= (string-length isbn) 13)) (not (= (string-length isbn)
		       18))) #f)
		     ((let ( (a (rek isbn (- (string-length isbn) 3) 2)) )		;mit a = rek(isbn,length-3,2) do:
		    	   ( if (eqv? a #f) #f 
		    	  	(eqv? (- 11 (modulo a 11)) check)
		    	  )
		    ))
		    (else #f)
		)
	)
)